Đến nội dung


Hình ảnh
- - - - -

Lisp Hỗ Trợ In Nhiều Bản Vẽ 2016


  • Please log in to reply
3 replies to this topic

#1 dth_hn

dth_hn

    Chưa sử dụng CAD

  • Members
  • Pip
  • 4 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 23 May 2016 - 03:41 PM

Đã dùng nhiều tips trên diễn đàn nay mơi có điều kiện góp một cái.

Góp thêm một lisp in nhiều bản vẽ cho ace diễn đàn có thêm lựa chọn cho công việc.

Mình đã dùng nhiều chương trình in , mỗi cái có ưu và nhược điểm riêng. Vậy nên làm một cái cho riêng mình phù hợp, mọi người có thể chỉnh sửa tùy thuộc nhu cầu.

http://www.cadviet.c...27274_mplot.lsp

 

Sử dụng:

- Lisp dùng chọn các block khung tên, rectang, sau đó nhận dạng chu vi của polyline va block và thực hiện lệnh in.

- Lưu ý block khung tên nếu có đối tượng nằm ngoài rectang của khung tên thì nó sẽ in cả ra ngoài đấy ạ

- Do lisp không có phần đặt chọn máy in, cái này đối với tôi không cần thiết (cũng do ngại viết thêm) nên trước khi in các bạn phải dùng lệnh in bình thường đặt máy in, chon file stb, kích thước giấy vvv. Khi in chương trình sẽ chọn các thông số in lần gần nhất.

- Tôi hay in pdf và sử dụng pdf factor pro nên thấy rất ok.

- Tùy theo kích thước giấy ngang dọc , chương trình sẽ tự động xoay giấy cho phù hợp

 

Tiêu chí in đơn giản gọn nhệ, bạn nào cần phát triển thêm theo nhu cầu thì sửa lại code một chút

 

code đây ạ (không hiểu sao không hiện được phần code ở dưới, các bác xem trên file lsp vậy)

(defun c:mp (/ i ss minExt maxExt)
  ;;(vl-load-com)
  ;(Init)
  (Defun *Error* (Msg)
    (Setvar "BACKGROUNDPLOT" ha_plot)
    (Princ "\nerror: ")
    (Princ Msg)
    (Princ "  ")
    (Setq *Error* Olderr)
    (Princ)
  )
  (Setq Olderr *Error*)
  (Setq ha_plot (Getvar "BACKGROUNDPLOT"))
  (Setvar "BACKGROUNDPLOT" 0)
  (princ "Select BLOCK/LWPOLYLINE ...\n")
  (if (setq ss (ssget '((0 . "INSERT,LWPOLYLINE,AcDbBlockReference"))))
    (progn
 (setq i 0)
      (repeat (sslength ss)
(vla-getboundingbox
 (vlax-ename->vla-object (ssname ss i))
 'minExt
 'maxExt
)
(setq i (1+ i))
(_SetWindowToPlot minExt maxExt)
      )
    )
  )
  (Setvar "BACKGROUNDPLOT" ha_plot)
  (Setq *Error* Olderr)
  ;(Reinit)
  (princ)
)
 
(defun _SetWindowToPlot(point1 point2 / pointTemp1 pointTemp2 X1 X2 Y1 Y2 Xdist Ydist)
;;(vl-load-com)
;; This example allows the user to define an area in the current layout to plot
;; and displays a plot preview of the defined area.
;;
;; * Note: You will have to exit the plot preview
;;  before the VBA example will stop and control will be returned
 
(setq acadObj (vlax-get-acad-object))
(setq doc (vla-get-ActiveDocument acadObj))
 
 
;; Translate the point into UCS coordinates in modelspace
(setq point1 (vlax-variant-value
  (vla-TranslateCoordinates
(vla-get-Utility doc)
point1
acWorld
acDisplayDCS
:vlax-false
  )
)
)
(setq point2 (vlax-variant-value
  (vla-TranslateCoordinates
(vla-get-Utility doc)
point2
acWorld
acDisplayDCS
:vlax-false
  )
)
)
 
    ;; Change this to a 2D array by removing the Z position
    (setq pointTemp1 (vlax-make-safearray vlax-vbDouble '(0 . 1)))
    (vlax-safearray-put-element pointTemp1 0 (vlax-safearray-get-element point1 0))
    (vlax-safearray-put-element pointTemp1 1 (vlax-safearray-get-element point1 1))
    
    ;; Change this to a 2D array by removing the Z position
    (setq pointTemp2 (vlax-make-safearray vlax-vbDouble '(0 . 1)))
    (vlax-safearray-put-element pointTemp2 0 (vlax-safearray-get-element point2 0))
    (vlax-safearray-put-element pointTemp2 1 (vlax-safearray-get-element point2 1))
    
    ;; Send information about window to current layout
    (vla-SetWindowToPlot (vla-get-ActiveLayout doc) pointTemp1 pointTemp2)
    
    ;; Read back window information
    (vla-GetWindowToPlot (vla-get-ActiveLayout doc) 'point1 'point2)
 
    ;; plotrotation
(setq X1 (vlax-safearray-get-element point1 0)
X2 (vlax-safearray-get-element point2 0)
Y1 (vlax-safearray-get-element point1 1)
Y2 (vlax-safearray-get-element point2 1)
)
;(setq test (abs (- X1 X2)))
(setq Xdist (abs (- X1 X2))
Ydist (abs (- Y1 Y2))
)
(if (<= Xdist Ydist)
(progn
(vla-put-plotrotation (vla-get-ActiveLayout doc) ac90degrees) ;;landscape
)
(vla-put-plotrotation (vla-get-ActiveLayout doc) ac0degrees) ;;potrait
)
;; Make sure the instruction is to plot a view, not some other plot style
(vla-put-PlotType (vla-get-ActiveLayout doc) acWindow)
 
;; Send Plot To Window - A plot device must be set before a preview can be created
;;(vla-put-ConfigName (vla-get-ActiveLayout doc) "Zan Image Printer(bw)")
;;(vla-DisplayPlotPreview (vla-get-Plot doc) acFullPreview)
(vla-PlotToDevice (vla-get-Plot doc))
)
 
(vl-load-com)
(princ "\nType \"mp\" in command.")
(princ)

  • 0

#2 thainguyen_tg

thainguyen_tg

    biết vẽ circle

  • Members
  • PipPip
  • 35 Bài viết
Điểm đánh giá: -6 (bình thường)

Đã gửi 23 May 2016 - 08:25 PM

 

Đã dùng nhiều tips trên diễn đàn nay mơi có điều kiện góp một cái.

Góp thêm một lisp in nhiều bản vẽ cho ace diễn đàn có thêm lựa chọn cho công việc.

Mình đã dùng nhiều chương trình in , mỗi cái có ưu và nhược điểm riêng. Vậy nên làm một cái cho riêng mình phù hợp, mọi người có thể chỉnh sửa tùy thuộc nhu cầu.

http://www.cadviet.c...27274_mplot.lsp

 

Sử dụng:

- Lisp dùng chọn các block khung tên, rectang, sau đó nhận dạng chu vi của polyline va block và thực hiện lệnh in.

- Lưu ý block khung tên nếu có đối tượng nằm ngoài rectang của khung tên thì nó sẽ in cả ra ngoài đấy ạ

- Do lisp không có phần đặt chọn máy in, cái này đối với tôi không cần thiết (cũng do ngại viết thêm) nên trước khi in các bạn phải dùng lệnh in bình thường đặt máy in, chon file stb, kích thước giấy vvv. Khi in chương trình sẽ chọn các thông số in lần gần nhất.

- Tôi hay in pdf và sử dụng pdf factor pro nên thấy rất ok.

- Tùy theo kích thước giấy ngang dọc , chương trình sẽ tự động xoay giấy cho phù hợp

 

Tiêu chí in đơn giản gọn nhệ, bạn nào cần phát triển thêm theo nhu cầu thì sửa lại code một chút

 

code đây ạ (không hiểu sao không hiện được phần code ở dưới, các bác xem trên file lsp vậy)

(defun c:mp (/ i ss minExt maxExt)
  ;;(vl-load-com)
  ;(Init)
  (Defun *Error* (Msg)
    (Setvar "BACKGROUNDPLOT" ha_plot)
    (Princ "\nerror: ")
    (Princ Msg)
    (Princ "  ")
    (Setq *Error* Olderr)
    (Princ)
  )
  (Setq Olderr *Error*)
  (Setq ha_plot (Getvar "BACKGROUNDPLOT"))
  (Setvar "BACKGROUNDPLOT" 0)
  (princ "Select BLOCK/LWPOLYLINE ...\n")
  (if (setq ss (ssget '((0 . "INSERT,LWPOLYLINE,AcDbBlockReference"))))
    (progn
 (setq i 0)
      (repeat (sslength ss)
(vla-getboundingbox
 (vlax-ename->vla-object (ssname ss i))
 'minExt
 'maxExt
)
(setq i (1+ i))
(_SetWindowToPlot minExt maxExt)
      )
    )
  )
  (Setvar "BACKGROUNDPLOT" ha_plot)
  (Setq *Error* Olderr)
  ;(Reinit)
  (princ)
)
 
(defun _SetWindowToPlot(point1 point2 / pointTemp1 pointTemp2 X1 X2 Y1 Y2 Xdist Ydist)
;;(vl-load-com)
;; This example allows the user to define an area in the current layout to plot
;; and displays a plot preview of the defined area.
;;
;; * Note: You will have to exit the plot preview
;;  before the VBA example will stop and control will be returned
 
(setq acadObj (vlax-get-acad-object))
(setq doc (vla-get-ActiveDocument acadObj))
 
 
;; Translate the point into UCS coordinates in modelspace
(setq point1 (vlax-variant-value
  (vla-TranslateCoordinates
(vla-get-Utility doc)
point1
acWorld
acDisplayDCS
:vlax-false
  )
)
)
(setq point2 (vlax-variant-value
  (vla-TranslateCoordinates
(vla-get-Utility doc)
point2
acWorld
acDisplayDCS
:vlax-false
  )
)
)
 
    ;; Change this to a 2D array by removing the Z position
    (setq pointTemp1 (vlax-make-safearray vlax-vbDouble '(0 . 1)))
    (vlax-safearray-put-element pointTemp1 0 (vlax-safearray-get-element point1 0))
    (vlax-safearray-put-element pointTemp1 1 (vlax-safearray-get-element point1 1))
    
    ;; Change this to a 2D array by removing the Z position
    (setq pointTemp2 (vlax-make-safearray vlax-vbDouble '(0 . 1)))
    (vlax-safearray-put-element pointTemp2 0 (vlax-safearray-get-element point2 0))
    (vlax-safearray-put-element pointTemp2 1 (vlax-safearray-get-element point2 1))
    
    ;; Send information about window to current layout
    (vla-SetWindowToPlot (vla-get-ActiveLayout doc) pointTemp1 pointTemp2)
    
    ;; Read back window information
    (vla-GetWindowToPlot (vla-get-ActiveLayout doc) 'point1 'point2)
 
    ;; plotrotation
(setq X1 (vlax-safearray-get-element point1 0)
X2 (vlax-safearray-get-element point2 0)
Y1 (vlax-safearray-get-element point1 1)
Y2 (vlax-safearray-get-element point2 1)
)
;(setq test (abs (- X1 X2)))
(setq Xdist (abs (- X1 X2))
Ydist (abs (- Y1 Y2))
)
(if (<= Xdist Ydist)
(progn
(vla-put-plotrotation (vla-get-ActiveLayout doc) ac90degrees) ;;landscape
)
(vla-put-plotrotation (vla-get-ActiveLayout doc) ac0degrees) ;;potrait
)
;; Make sure the instruction is to plot a view, not some other plot style
(vla-put-PlotType (vla-get-ActiveLayout doc) acWindow)
 
;; Send Plot To Window - A plot device must be set before a preview can be created
;;(vla-put-ConfigName (vla-get-ActiveLayout doc) "Zan Image Printer(bw)")
;;(vla-DisplayPlotPreview (vla-get-Plot doc) acFullPreview)
(vla-PlotToDevice (vla-get-Plot doc))
)
 
(vl-load-com)
(princ "\nType \"mp\" in command.")
(princ)

 

Sao chọn nhiều bản vẽ mà chỉ in dc 1 bv đầu tiên thôi bạn ơi!


  • 0

#3 dth_hn

dth_hn

    Chưa sử dụng CAD

  • Members
  • Pip
  • 4 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 24 May 2016 - 09:27 PM

Sao chọn nhiều bản vẽ mà chỉ in dc 1 bv đầu tiên thôi bạn ơi!

Bạn in ra máy in bình thường. Nếu in pdf thì dùng pdffactor,

nêu dùng máy in pdf mặc định của cad thì chỉ in được từng bản một thôi, cái này tôi không dùng nên chưa tìm hiểu để sửa


  • 0

#4 kienxd04

kienxd04

    biết vẽ pline

  • Members
  • PipPip
  • 63 Bài viết
Điểm đánh giá: 2 (bình thường)

Đã gửi 16 June 2016 - 01:12 PM

cái này có in được trong layout ko bạn, mình đang cần cái này.


  • 0